/*
 * Copyright (c) 2006, TopCoder, Inc. All rights reserved.
 *
 * Author: TCSDEVELOPER, TCSDESIGNER
 * Version: 1.0
 */

using System;

namespace TopCoder.Test.Framework.Servers
{
    /// <summary>
    /// This exception is derived from <see cref="ApplicationException"/>. This exception is thrown by the classes
    /// derived from <see cref="Server"/>, when any error happen while processing. It is also thrown by the
    /// <see cref="ServerElement"/> class, when it fails to create a corresponding class derived from
    /// <see cref="Server"/>.
    /// </summary>
    public class ServerException : ApplicationException
    {
        /// <summary>
        /// Constructs an exception with the error message string.
        /// </summary>
        /// <param name="message">The message string to use.</param>
        public ServerException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Constructs an exception with the error message string and inner exception.
        /// </summary>
        /// <param name="message">The message string to use.</param>
        /// <param name="innerException">The inner exception/cause to use.</param>
        public ServerException(string message, Exception innerException)
            : base(message, innerException)
        {
        }
    }
}
