/*
 * Copyright (c) 2006, TopCoder, Inc. All rights reserved.
 *
 * Author: TCSDEVELOPER, TCSDESIGNER
 * Version: 1.0
 */

using NAnt.Core;
using NUnit.Extensions.Asp;
using NUnit.Framework;
using System.IO;

namespace TopCoder.Test.Framework
{
    /// <summary>
    /// This is a demo. It contains an NUnitAsp based test case, which is started through a special NAnt build file.
    /// </summary>
    [TestFixture]
    public class Demo
    {
        /// <summary>
        /// A file used to tell the internal tests whether they actually should run at this time. This is the simplest
        /// solution, when we don't have real NUnit 2.2 "categories".
        /// </summary>
        public const string HINTFILE = @"..\..\test_files\hint";

        /// <summary>
        /// Sample unit test, using NUnitAsp, for more detailed tutorial visit http://nunitasp.sourceforge.net
        /// </summary>
        [TestFixture]
        public class ServerDemoTest : WebFormTestCase
        {
            /// <summary>
            /// This method performs initialization before every test.
            /// </summary>
            protected override void SetUp()
            {
                if (File.Exists(HINTFILE))
                {
                    // Open the page to test
                    Browser.GetPage("http://localhost/");
                    // Do something other here
                }
            }

            /// <summary>
            /// This method performs clean-up after every test
            /// </summary>
            protected override void TearDown()
            {
                // Do something here
            }

            /// <summary>
            /// Test something.
            /// </summary>
            [Test]
            public void TestLayout()
            {
                // Do something here,
                // then use the AssertXXX methods to chech the results
            }
        }

        /// <summary>
        /// Sets up the testing fixture
        /// </summary>
        [SetUp]
        public void Setup()
        {
            using (File.Create(HINTFILE))
            {
            }
        }

        /// <summary>
        /// Remove the "hint file".
        /// </summary>
        [TearDown]
        public void Teardown()
        {
            File.Delete(HINTFILE);
        }

        /// <summary>
        /// Executes the test method itself. Normally, of course, NAnt would be used from the command line.
        /// </summary>
        [Test]
        public void DemoMethod()
        {
            new Project(@"..\..\test_files\demo.build", Level.Info).Execute();
        }
    }
}
